/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

/* ***********************************************************
* This file was automatically generated on 2020-04-08.      *
*                                                           *
* openHAB Bindings Version 2.0.0                            *
*                                                           *
* If you have a bugfix for this file and want to commit it, *
* please fix the bug in the generator. You can find a link  *
* to the generators git repository on tinkerforge.com       *
*************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import com.tinkerforge.BrickletIO16V2;
import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the IO-16 Bricklet 2.0.
 * 
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIO16V2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) {
        this.handler = (DeviceHandler) handler;
    }

    @Override
    public @Nullable ThingHandler getThingHandler() {
        return handler;
    }

    @RuleAction(label = "Set Value")
    public void brickletIO16V2SetValue(@ActionInput(name = "value") boolean[] value) throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setValue(value);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin15"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin15"), RefreshType.REFRESH);
        }
    }

    public static void brickletIO16V2SetValue(@Nullable ThingActions actions, boolean[] value)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            ((BrickletIO16V2Actions) actions).brickletIO16V2SetValue(value);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Set Selected Value")
    public void brickletIO16V2SetSelectedValue(@ActionInput(name = "channel") int channel,
            @ActionInput(name = "value") boolean value) throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setSelectedValue(channel, value);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin15"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin15"), RefreshType.REFRESH);
        }
    }

    public static void brickletIO16V2SetSelectedValue(@Nullable ThingActions actions, int channel, boolean value)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            ((BrickletIO16V2Actions) actions).brickletIO16V2SetSelectedValue(channel, value);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Set Monoflop")
    public void brickletIO16V2SetMonoflop(@ActionInput(name = "channel") int channel,
            @ActionInput(name = "value") boolean value, @ActionInput(name = "time") long time)
            throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setMonoflop(channel, value, time);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2OutputPin15"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2MonoflopPin15"), RefreshType.REFRESH);
        }
    }

    public static void brickletIO16V2SetMonoflop(@Nullable ThingActions actions, int channel, boolean value, long time)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            ((BrickletIO16V2Actions) actions).brickletIO16V2SetMonoflop(channel, value, time);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Value")
    public @ActionOutput(name = "value", type = "boolean[]") Map<String, Object> brickletIO16V2GetValue()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        boolean[] value = dev.getValue();

        result.put("value", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetValue(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetValue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Configuration")
    public @ActionOutput(name = "direction", type = "char") @ActionOutput(name = "value", type = "boolean") Map<String, Object> brickletIO16V2GetConfiguration(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIO16V2.Configuration value = dev.getConfiguration(channel);

        result.put("direction", value.direction);
        result.put("value", value.value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetConfiguration(@Nullable ThingActions actions, int channel)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetConfiguration(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Edge Count")
    public @ActionOutput(name = "count", type = "long") Map<String, Object> brickletIO16V2GetEdgeCount(
            @ActionInput(name = "channel") int channel, @ActionInput(name = "resetCounter") boolean resetCounter)
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }
        Thing t = h.getThing();
        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        long value = dev.getEdgeCount(channel, resetCounter);
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin0")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin0"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin1")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin1"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin2")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin2"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin3")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin3"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin4")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin4"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin5")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin5"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin6")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin6"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin7")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin7"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin8")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin8"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin9")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin9"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin10")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin10"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin11")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin11"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin12")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin12"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin13")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin13"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin14")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin14"), RefreshType.REFRESH);
        }
        if (t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin15")) != null) {
            h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCountPin15"), RefreshType.REFRESH);
        }
        result.put("count", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetEdgeCount(@Nullable ThingActions actions, int channel,
            boolean resetCounter) throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetEdgeCount(channel, resetCounter);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Monoflop")
    public @ActionOutput(name = "value", type = "boolean") @ActionOutput(name = "time", type = "long") @ActionOutput(name = "timeRemaining", type = "long") Map<String, Object> brickletIO16V2GetMonoflop(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIO16V2.Monoflop value = dev.getMonoflop(channel);

        result.put("value", value.value);
        result.put("time", value.time);
        result.put("timeRemaining", value.timeRemaining);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetMonoflop(@Nullable ThingActions actions, int channel)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetMonoflop(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Edge Count Configuration")
    public @ActionOutput(name = "edgeType", type = "int") @ActionOutput(name = "debounce", type = "int") Map<String, Object> brickletIO16V2GetEdgeCountConfiguration(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIO16V2.EdgeCountConfiguration value = dev.getEdgeCountConfiguration(channel);

        result.put("edgeType", value.edgeType);
        result.put("debounce", value.debounce);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetEdgeCountConfiguration(@Nullable ThingActions actions,
            int channel) throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetEdgeCountConfiguration(channel);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type = "long") Map<String, Object> brickletIO16V2ReadUID()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        long value = dev.readUID();

        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2ReadUID(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2ReadUID();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type = "int") Map<String, Object> brickletIO16V2GetChipTemperature()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();

        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetChipTemperature(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetChipTemperature();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type = "int") Map<String, Object> brickletIO16V2GetStatusLEDConfig()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();

        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetStatusLEDConfig(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetStatusLEDConfig();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type = "long") @ActionOutput(name = "errorCountMessageChecksum", type = "long") @ActionOutput(name = "errorCountFrame", type = "long") @ActionOutput(name = "errorCountOverflow", type = "long") Map<String, Object> brickletIO16V2GetSPITFPErrorCount()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIO16V2.SPITFPErrorCount value = dev.getSPITFPErrorCount();

        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetSPITFPErrorCount(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetSPITFPErrorCount();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type = "String") @ActionOutput(name = "connectedUid", type = "String") @ActionOutput(name = "position", type = "char") @ActionOutput(name = "hardwareVersion", type = "int[]") @ActionOutput(name = "firmwareVersion", type = "int[]") @ActionOutput(name = "deviceIdentifier", type = "int") Map<String, Object> brickletIO16V2GetIdentity()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletIO16V2.Identity value = dev.getIdentity();

        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetIdentity(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletIO16V2Actions) {
            return ((BrickletIO16V2Actions) actions).brickletIO16V2GetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletIO16V2Actions class.");
        }
    }
}
